<?php
/**
 * Created by PhpStorm.
 * User: roc
 * Date: 2019/12/24
 * Time: 11:26
 */

namespace kwy\wechatapi\openwx;


class WxException extends \Exception
{
    private $api_data;

    public function __construct($data){
        if(!empty($data["errmsg"])) $message = $data["errmsg"];
        else $message = "微信接口调用异常";
        if(empty($data['status'])) $data['status'] = 1;
        parent::__construct($message,$data['status']);
        $this->api_data=$data;
    }

    /**
     * 获得 接口报错时 返回数组结果
     * @return array
     */
    public function getApiData(){
        return $this->api_data;
    }

    /**
     * 返回微信的code码
     * @author roc
     * @datetime:2019/12/24 11:29
     * @return string
     */
    public function getWxErrCode(){
        return empty($this->api_data['errcode']) ? '' : $this->api_data['errcode'];
    }
}