<?php
namespace kwy\wechatapi\walletpay;

use kwy\wechatapi\WechatConfig;
use kwy\wechatapi\WechatRequest;

class WalletPay extends WechatRequest{

    const API_URL="https://api.mch.weixin.qq.com/mmpaymkttransfers/promotion/transfers";

    protected $ssl=true;


    /**
     * @param $openid
     * @param $amount
     * @param $no
     * @param $desc
     * @return array
     * partner_trade_no商户订单号
     * payment_no微信付款单号
     * payment_time付款成功时间
     * @throws \Exception
     */
    public function pay($openid,$amount,$no,$desc){
        $biz_params=[
            'mchid'=>$this->getMchid(),
            'openid'=>$openid,//'oOCXdt5NkZk9xrQgcW6GKugb_WQQ',
            'mch_appid'=>$this->getAppid(),
            'check_name'=>'NO_CHECK',
            'amount'=>$amount,
            'desc'=>$desc,
            'partner_trade_no'=>$no,
            'spbill_create_ip'=>'115.29.165.48',
        ];

        $ret=$this->getBizResult(self::API_URL,$biz_params);
        if($ret['result_code']!=='SUCCESS'){
            throw new \Exception($ret['err_code_des'].', :'.$ret['err_code']);
        }
        return $ret;
    }

    /**
     * @param $no 商户发起交易时的内部流水号
     * @return array
     * @throws \Exception
     */
    public function query($no){
        $url='https://api.mch.weixin.qq.com/mmpaymkttransfers/gettransferinfo';
        $biz_params=[
            'partner_trade_no'=>$no,
            'appid'=>$this->getAppid(),
            'mch_id'=>$this->getMchid(),
        ];
        $ret=$this->getBizResult($url,$biz_params);
        if($ret['result_code']!=='SUCCESS'){
            throw new \Exception($ret['err_code_des'].', :'.$ret['err_code']);
        }
        return $ret;
    }
}
